<template>
  <div class="app-container">
    <div class="filter-container">
      <el-input v-model="search.keyWord" placeholder="关键字" style="width: 200px;" class="filter-item" @keyup.enter.native="searchData" />
      <el-button class="filter-item" type="primary" icon="el-icon-search" @click="searchData">
        搜索
      </el-button>

      <el-button
        v-if="webType && isChoose == false"
        class="filter-item"
        style="margin-left: 10px;"
        type="primary"
        icon="el-icon-plus"
        @click="handleCreateAdd">
        增加产品P数计价规格
      </el-button>
      <div class="top-right-btn">
      <el-tooltip class="item" effect="dark" content="刷新" placement="top">
        <el-button size="mini" circle icon="el-icon-refresh" @click="getPaperInfo" />
      </el-tooltip>
    </div>
    </div>
    <el-table
      :data="tableData"
      v-loading="listLoading"
      class="tb-edit"
      style="width: 100%;margin-bottom: 20px;"
      row-key="id"
      border
      highlight-current-row
      default-expand-all>
      <el-table-column
        prop="priceName"
        label="规则名称">
      </el-table-column>
      <el-table-column
        prop="price"
        label="单价">
      </el-table-column>
      <el-table-column align="center" label="状态" class-name="status-col">
        <template slot-scope="{row}">
          <el-tag v-if="row.voidFlag==0" type="success">
            启用
          </el-tag>
          <el-tag v-else-if="row.voidFlag==1" type="danger">
            禁用
          </el-tag>
        </template>
      </el-table-column>
      <el-table-column label="操作"  fixed='left' align="center" width="230" class-name="small-padding fixed-width">
        <template slot-scope="{row}">
          <template v-if="webType">
          <template v-if="!isChoose">
          <el-button @click="handleUpdate(row)" type="primary" size="mini">
            编辑
          </el-button>
          <el-button @click="editStatus(row.id,'1')" type="danger" v-if="row.voidFlag==0" size="mini">
            禁用
          </el-button>
          <el-button @click="editStatus(row.id,'0')" v-else-if="row.voidFlag==1" size="mini">
            启用
          </el-button>
          </template>
          <template v-else>
            <el-button @click="chooseThis(row)" type="primary" size="mini">
              选择
            </el-button>
          </template>
          </template>
          <template v-else>
            <el-button @click="ERPChoose(row)" type="primary" size="mini">
              选择
            </el-button>
          </template>
        </template>
      </el-table-column>

    </el-table>
    <pagination v-show="listData.total>0" :total="listData.total" :page.sync="listData.page" :limit.sync="listData.pageSize" @pagination="getPaperInfo" />

    <el-dialog :title="dialogTitle" :visible.sync="dialogVisible" width="600px">
      <el-form label-width="130px" label-position="right">
            <el-form-item label="规则名称">
              <el-input v-model="form.priceName"></el-input>
            </el-form-item>
        <el-form-item label="单价">
          <el-input v-model="form.price"></el-input>
        </el-form-item>
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button @click="dialogVisible = false">取 消</el-button>
        <el-button type="primary" @click="dialogStatus==='1'?addBtn():editBtn()">确 定</el-button>
      </div>
    </el-dialog>
<!--    <servicedialog @tableRefresh="tableRefresh" ref="menuDialog" :dialogStatus="dialogStatus" :menuId="menuId" :titleDialog="titleDialog" :dialogVisible="dialogVisible"/>-->
    <cancledialog @tableRefresh="tableRefresh" ref="confirmDialog"></cancledialog>
  </div>
</template>

<script>
import { getProductPagePriceList, getProductPagePriceInfo, addProductPagePrice, updateProductPagePrice} from '@/api/productFile/pagePrice'
import { getPaperTypeList } from '@/api/baseInfo/paper/paperType.js'
import Cancledialog from '@/components/Dialog/Cancledialog.vue'
import Pagination from '@/components/Pagination'

const form = {
  priceName: '',
  price: ''
}
export default {
  name: 'BasePaperInfo',
  components: {
    Cancledialog, Pagination
  },
  props: {
    isChoose: {
      type: Boolean,
      default: false
    },
    partId: {
      type: Number || String
    },
    productId: {
      type: Number || String
    }
  },
  data() {
    return {
      webType: true,
      dialogStatus: 1, // 1增加，2修改
      dialogTitle: '',
      dialogVisible: false,
      search: {
        keyWord: ''
      },
      form: Object.assign({}, form),
      typeOptions: [],
      priceOptions: [
        {
          label: '吨价',
          value: 0
        },
        {
          label: '平方单价',
          value: 1
        }
      ],

      listData: {
        total: 0,
        page: 1,
        pageSize: 10
      },

      confirmdialog: false,
      listLoading: false,
      tableData: [],
      menuId: ''
    }
  },
  mounted() {
    this.getPaperInfo()
    if (this.$route.query.type === undefined) {
      this.webType = true
    } else {
      this.webType = false
    }
  },
  methods: {
    // 获取列表
    getPaperInfo() {
      const _that = this
      _that.listLoading = true
      var params = _that.search
      var page = {
        pageIndex: _that.listData.page,
        pageSize: _that.listData.pageSize
      }
      var data = {
        'params': JSON.stringify(params),
        // 'page': JSON.stringify(page)
      }
      // console.log(data);
      getProductPagePriceList(data).then(response => {
        // console.log('基础纸张档案列表',response)
        const data = response.data
        // //  组合表单数据
        _that.tableData = data
        _that.listData.total = response.total
        // console.log(_that.tableData)
        _that.listLoading = false
      }).catch(err => {
        _that.$message.error(err)
        _that.listLoading = false
      })
    },

    // 获取纸张类型列表
    getPaperTypeInfo() {
      const _that = this
      _that.listLoading = true
      var data = {
        'params': JSON.stringify({
          'voidFlag': 0
        })
      }
      // console.log(data);
      getPaperTypeList(data).then(response => {
        // console.log(response)
        const data = response.data
        _that.typeOptions = data
      }).catch(err => {
      })
    },
    // 增加p数计价规则
    handleCreateAdd() {
      // 增加系统目录
      const _that = this
      _that.form = Object.assign({}, form)
      _that.dialogTitle = '增加p数计价规则'
      _that.dialogStatus = '1'
      _that.dialogVisible = true
    },
    // 刷新变革
    tableRefresh() {
      // 刷新变革
      this.getPaperInfo()
    },
    // 增加p数计价规则
    addBtn() {
      const _that = this
      var info = JSON.stringify(_that.form)
      var data = {
        'priceInfo': info
      }
      // console.log(data);
      // return

      addProductPagePrice(data).then(res => {
        // console.log(res);
        if (res.httpCode == 200) {
          _that.dialogVisible = false
          _that.$message({
            message: '增加成功',
            type: 'success'
          })
          _that.tableRefresh()
        } else {
          _that.$message.error(res.msg)
        }
      }).catch(err => {
        _that.$message.error(err)
        _that.dialogVisible = true
      })
    },

    getPaper(id) {
      var _that = this
      var data = {
        id: id
      }

      getProductPagePriceInfo(data).then(res => {
        // console.log('获取信息', res)
        const data = res.data
        _that.form = {
          id: data.id,
          priceName: data.priceName,
          price: data.price,
        }
      }).catch(err => {
        _that.$message.error(err)
      })
    },
    // 唤起修改
    handleUpdate(row) {
      const _that = this
      _that.form = Object.assign({}, form)

      _that.dialogTitle = '修改p数计价规则'
      _that.dialogVisible = true
      _that.dialogStatus = '2'

      var idPrint = row.id
      _that.getPaper(idPrint)
    },
    // 修改p数计价规则
    editBtn() {
      const _that = this
      var info = JSON.stringify(_that.form)
      var data = {
        'priceInfo': info
      }

      updateProductPagePrice(data).then(res => {
        // console.log(res);
        if (res.httpCode == 200) {
          _that.dialogVisible = false
          _that.$message({
            message: '修改成功',
            type: 'success'
          })
          _that.tableRefresh()
        } else {
          _that.$message.error(res.msg)
        }
      }).catch(err => {
        _that.$message.error(err)
        _that.dialogVisible = true
      })
    },

    // 启用禁用
    editStatus(id, status) {
      var _that = this
      var printerTypeInfo = {
        id: id,
        voidFlag: status
      }
      var params = {
        'priceInfo': JSON.stringify(printerTypeInfo)
      }

      var url = '/product/voidProductPagePrice'
      _that.$refs.confirmDialog.updataClick(params, url)
    },

    // 搜索
    searchData() {
      this.listData.page = 1
      this.getPaperInfo()
    },


    // 弹窗内选择操作
    chooseThis(row) {
      // console.log('点击选择');
      this.$emit('choosePaper', row)
    },
    ERPChoose(row) {
      // this.$message.error(row)
      dyERP.sendJson(JSON.stringify(row))
    }

  }
}
</script>
<style>
  /*处理input type = number的上下箭头*/
  input::-webkit-outer-spin-button,
  input::-webkit-inner-spin-button {
    -webkit-appearance: none;
  }
  input[type="number"]{
    -moz-appearance: textfield;
  }
</style>
<style lang="scss" scoped>
  .filter-container {
    margin-bottom: 15px;
  }

  .tb-edit .el-input {
    display: none
  }
  .tb-edit .current-row .el-input {
    display: block
  }
  .tb-edit .current-row .el-input+span {
    display: none
  }

</style>
